Full Circle Query v2 REST API Python Samples
=======================================================
These samples demonstrate basic usage of the Full Circle Query v2 REST API.

## Prerequisites
- [`Python 2.7.9+`](https://www.python.org/)
- [`Pip`](https://pip.pypa.io/en/stable/)

## Before you start
These instructions assume you have already created a project in the
[Google Developers Console](https://console.developers.google.com/) to store
your query results in Big Query and have worked with the Ads Data Hub support
team to grant it access to the Full Circle Query API. **If you have not
done so already, you should reach out to the Ads Data Hub support team via
adh-support@google.com to configure your access to the API.**

## Setup
To run these samples, you'll need to do the following:

1. Download and install the dependencies used in these samples by running the
   following command:

   ```
   $ pip install -r requirements.txt
   ```
   **Note:** If you do not have pip installed, you can find installation
   instructions [here](https://pip.pypa.io/en/stable/installing/#installation).
1. If you haven't done so already, you should read about the OAuth 2.0
   [Installed Application Flow](https://developers.google.com/identity/protocols/OAuth2InstalledApp),
   the flow used by these samples for authorization to access the Full Circle
   Query v2 API.
1. Go to the [Google Developers Console](https://console.developers.google.com/)
   and verify that you have access to the Full Circle Query project via the
   drop-down menu at the top of the page. **If you don't see the Full Circle
   Query project, you should reach out to the Ads Data Hub support team to get
   access.**
1. From the project drop-down menu, select your Big Query project.
1. Click on the hamburger button on the top left corner of the page and click
   **APIs & services > Credentials**.
1. If you have not done so already, create an API key by clicking the **Create
   credentials** drop-down menu and select **API key**. This will create an API
   key that you will need for a later step.
1. If you have not done so already, create a new OAuth 2.0 client ID by
   clicking the **Create credentials** button and select **OAuth client ID**.
   For the **Application type** select **Other** and optionally enter a name to
   be associated with the client ID. Click **Create** to create the new Client
   ID and a dialog will appear to show you your client ID and secret. On the
   [Credentials page](https://pantheon.corp.google.com/apis/credentials) for
   your project, find your new client ID listed under **OAuth 2.0 client IDs**,
   and click the corresponding download icon. The downloaded file will contain
   your credentials, which will be needed to step through the OAuth 2.0
   installed application flow.
1. Open **samples_util.py** and update the `DEVELOPER_KEY` field to match the
   API key you retrieved earlier.
1. In **samples_util.py**, update the `CLIENT_SECRETS_FILE` field to represent
   the path to the credentials file you downloaded earlier; if you placed it in
   the sample directory, this should just be the filename.
1. Before attempting to run any of the samples, you should update any fields
   containing default values for data sent in API requests. Alternatively, you
   can also provide values for these fields at run-time as command-line
   arguments.

You should now be able to start any of the samples by running them from the
command line, for example:

```
$ python list_customers.py
```

**Note:** You will need to step through the OAuth 2.0 installed application
flow the first time you run these samples. After you step through the flow,
credentials will be saved locally and used automatically in subsequent runs.

## Technical support

For technical questions and support relating to these samples or the API,
please contact our support alias: adsdatahubapi-support@google.com

