#!/usr/bin/python
#
# Copyright 2017 Google Inc. All Rights Reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#      http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

"""This examples lists Ads Data Hub customers for the authenticated user."""

import pprint
import sys

from googleapiclient.errors import HttpError
import samples_util


def main(full_circle_query):
  try:
    # Execute the request.
    response = full_circle_query.customers().list().execute()
  except HttpError as e:
    print e
    sys.exit(1)

  if 'customers' in response:
    print 'Found the following Ads Data Hub customers for the current user:'
    for customer in response['customers']:
      pprint.pprint(customer)
  else:
    print 'No customers found for current user.'


if __name__ == '__main__':
  try:
    service = samples_util.GetService()
  except IOError, ex:
    print 'Unable to create ads data hub service - %s' % ex
    print 'Did you specify the client secrets file in samples_util.py?'
    sys.exit(1)

  main(service)
